Scriptname mzinInterfaceNeeds extends Quest  

Event OnInit()
	RegisterForModEvent("mzin_Int_PlayerLoadsGame", "On_mzin_Int_PlayerLoadsGame")
EndEvent

Event On_mzin_Int_PlayerLoadsGame(string eventName, string strArg, float numArg, Form sender)
	PlayerLoadsGame()
EndEvent

Function PlayerLoadsGame()
	If Game.GetModByName("RealisticNeedsandDiseases.esp") != 255
		If GetState() != "Rnd"
			GoToState("Rnd")
		EndIf
		
	ElseIf Game.GetModByName("iNeed.esp") != 255
		If GetState() != "Ineed"
			GoToState("Ineed")
		EndIf
	
	Else
		If GetState() != ""
			GoToState("")
		EndIf
	EndIf
EndFunction

Bool Function GetIsInterfaceActive()
	If GetState() != ""
		Return true
	EndIf
	Return false
EndFunction

Form Function GetWaterBottle()
	Form akForm
	Int i = mzinWaterBottleForms.GetSize()
	While i > 0
		i -= 1
		akForm = mzinWaterBottleForms.GetAt(i)
		If PlayerRef.GetItemCount(akForm) > 0
			Return akForm
		EndIf
	EndWhile
	Return None
EndFunction

; Installed =======================================

State Rnd
	Event OnBeginState()
		mzinWaterSkinForms.Revert()
		mzinWaterSkinForms.AddForm(Game.GetFormFromFile(0x047F94, "RealisticNeedsandDiseases.esp"))
		mzinWaterSkinForms.AddForm(Game.GetFormFromFile(0x0449AB, "RealisticNeedsandDiseases.esp"))
		mzinWaterSkinForms.AddForm(Game.GetFormFromFile(0x047FA2, "RealisticNeedsandDiseases.esp"))
	
		mzinWaterBottleForms.Revert()
		mzinWaterBottleForms.AddForm(Game.GetFormFromFile(0x0053F0, "RealisticNeedsandDiseases.esp"))
		mzinWaterBottleForms.AddForm(Game.GetFormFromFile(0x00FB99, "RealisticNeedsandDiseases.esp"))
		mzinWaterBottleForms.AddForm(Game.GetFormFromFile(0x00FB9B, "RealisticNeedsandDiseases.esp"))
		mzinWaterBottleForms.AddForm(Game.GetFormFromFile(0x0053E9, "RealisticNeedsandDiseases.esp"))
		mzinWaterBottleForms.AddForm(Game.GetFormFromFile(0x00FBA5, "RealisticNeedsandDiseases.esp"))
		mzinWaterBottleForms.AddForm(Game.GetFormFromFile(0x00FBA7, "RealisticNeedsandDiseases.esp"))
		mzinWaterBottleForms.AddForm(Game.GetFormFromFile(0x05B2C0, "RealisticNeedsandDiseases.esp"))
		mzinWaterBottleForms.AddForm(Game.GetFormFromFile(0x047FB6, "RealisticNeedsandDiseases.esp"))
		mzinWaterBottleForms.AddForm(Game.GetFormFromFile(0x047FA2, "RealisticNeedsandDiseases.esp"))
		mzinWaterBottleForms.AddForm(Game.GetFormFromFile(0x0449AB, "RealisticNeedsandDiseases.esp"))
		mzinWaterBottleForms.AddForm(Game.GetFormFromFile(0x047F94, "RealisticNeedsandDiseases.esp"))
	EndEvent
	
	Function ReturnEmptyContainer(Form FullBottle)
		If mzinWaterSkinForms.HasForm(FullBottle) ; Is a waterskin
			PlayerRef.AddItem(Game.GetFormFromFile(0x046497, "RealisticNeedsandDiseases.esp"))
		Else ; Otherwise just give an empty bottle
			PlayerRef.AddItem(Game.GetFormFromFile(0x0043B4, "RealisticNeedsandDiseases.esp"))
		EndIf
	EndFunction
EndState

State Ineed
	Event OnBeginState()
		mzinWaterSkinForms.Revert()
		mzinWaterBottleForms.Revert()
		mzinWaterBottleForms.AddForm(Game.GetFormFromFile(0x03B2CC, "iNeed.esp"))
		mzinWaterBottleForms.AddForm(Game.GetFormFromFile(0x004376, "iNeed.esp"))
	EndEvent
	
	Function ReturnEmptyContainer(Form FullBottle)
		PlayerRef.AddItem(Game.GetFormFromFile(0x00438C, "iNeed.esp"))
	EndFunction
EndState

Event OnBeginState()
	mzinWaterBottleForms.Revert()
EndEvent

Function ReturnEmptyContainer(Form FullBottle)
EndFunction

; Not Installed ====================================

Event OnEndState()
	Utility.Wait(5.0) ; Wait before entering active state to help avoid making function calls to scripts that may not have initialized yet.

EndEvent

Formlist Property mzinWaterBottleForms Auto
Formlist Property mzinWaterSkinForms Auto

Actor Property PlayerRef Auto
